<?php
/**
* Class contact
*
* contact module class
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>            
* @module		contact
* @modulegroup	core_modules
* @access		public
* @version		1.0.0
*/
require_once ASCMS_CORE_MODULE_PATH.'/contact/lib/ContactLib.class.php';

class ContactManager extends ContactLib
{
	var $_objTpl;
	
	var $_statusMessage;
	
	var $_arrFormFieldTypes;
	
	/**
	* Constructor
	*/
	function ContactManager()
	{
		$this->__construct();
	}
	
	/**
	* PHP5 constructor
	*
	* @global object $objTemplate
	* @global array $_CORELANG
	*/
	function __construct()
	{
		global $objTemplate, $_ARRAYLANG;
		
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_CORE_MODULE_PATH.'/contact/template');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
    	
    	$objTemplate->setVariable("CONTENT_NAVIGATION", "	<a href='index.php?cmd=contact' title=".$_ARRAYLANG['TXT_CONTACT_CONTACT_FORMS'].">".$_ARRAYLANG['TXT_CONTACT_CONTACT_FORMS']."</a>
    														<a href='index.php?cmd=contact&amp;act=settings' title=".$_ARRAYLANG['TXT_CONTACT_SETTINGS'].">".$_ARRAYLANG['TXT_CONTACT_SETTINGS']."</a>");
    	
    	$this->_arrFormFieldTypes = array(
    		'text'			=> $_ARRAYLANG['TXT_CONTACT_TEXTBOX'],
			'checkbox'		=> $_ARRAYLANG['TXT_CONTACT_CHECKBOX'],
			'checkboxGroup'	=> $_ARRAYLANG['TXT_CONTACT_CHECKBOX_GROUP'],
			'file'			=> $_ARRAYLANG['TXT_CONTACT_FILE_UPLOAD'],
			'hidden'		=> $_ARRAYLANG['TXT_CONTACT_HIDDEN_FIELD'],
			'password'		=> $_ARRAYLANG['TXT_CONTACT_PASSWORD_FIELD'],
			'radio'			=> $_ARRAYLANG['TXT_CONTACT_RADIO_BOXES'],
			'select'		=> $_ARRAYLANG['TXT_CONTACT_SELECTBOX'],
			'textarea'		=> $_ARRAYLANG['TXT_CONTACT_TEXTAREA']
		);
    	
    	$this->initContactForms();
	}
	
	/**
	* Get page
	*
	* Get the development page
	*
	* @access public
	* @global object $objTemplate
	*/
	function getPage() 
	{
		global $objTemplate, $_CORELANG, $objPerm;
		
		if (!isset($_REQUEST['act'])) {
			$_REQUEST['act'] = '';
		}
		
		if (!isset($_REQUEST['tpl'])) {
			$_REQUEST['tpl'] = '';
		}
		
		switch ($_REQUEST['act']) {
		case 'settings':
			$objPerm->checkAccess(85, 'static');
			$this->_getSettingsPage();
			break;
		
		case 'entries':
			$this->_getEntriesPage();
			break;
			
		default:
			$this->_getContactFormPage();
			break;
		}
		
		$objTemplate->setVariable(array(
			'CONTENT_TITLE'				=> $_CORELANG['TXT_CONTACTS'],
			'CONTENT_STATUS_MESSAGE'	=> $this->_statusMessage,
			'ADMIN_CONTENT'				=> $this->_objTpl->get()
		));
	}
	
	function _getEntriesPage()
	{
		global $_ARRAYLANG;
		
		$entryId = isset($_REQUEST['entryId']) ? intval($_REQUEST['entryId']) : 0;
		$formId = isset($_REQUEST['formId']) ? intval($_REQUEST['formId']) : 0;
		
		$arrEntry = &$this->getFormEtry($entryId);
		
		if (is_array($arrEntry)) {
			
			$this->_objTpl->loadTemplateFile('module_contact_entries_details.html');
			
			$this->_objTpl->setVariable(array(
				'CONTACT_FORM_ENTRY_ID'	=> $entryId,
				'CONTACT_ENTRY_TITLE'	=> str_replace('%DATE%', date(ASCMS_DATE_FORMAT, $arrEntry['time']), $_ARRAYLANG['TXT_CONTACT_ENTRY_OF_DATE']),
				'CONTACT_ENTRY'			=> $this->_getEntryDetails($arrEntry, $formId),
				'CONTACT_FORM_ID'		=> $formId,
				'TXT_CONTACT_BACK'		=> $_ARRAYLANG['TXT_CONTACT_BACK'],
				'TXT_CONTACT_DELETE'	=> $_ARRAYLANG['TXT_CONTACT_DELETE'],
				'TXT_CONTACT_CONFIRM_DELETE_ENTRY'	=> $_ARRAYLANG['TXT_CONTACT_CONFIRM_DELETE_ENTRY'],
				'TXT_CONTACT_ACTION_IS_IRREVERSIBLE'	=> $_ARRAYLANG['TXT_CONTACT_ACTION_IS_IRREVERSIBLE']
			));
		} else {
			$this->_contactFormEntries();
		}
	}
	
	function _getSettingsPage()
	{
		switch ($_REQUEST['tpl']) {
		case 'save':
			$this->_saveSettings();
			
		default:
			$this->_settings();
			break;
		}
	}
	
	function _settings()
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->loadTemplateFile('module_contact_settings.html');
		
		$arrSettings = &$this->getSettings();
		
		$this->_objTpl->setVariable(array(
			'TXT_CONTACT_SETTINGS'						=> $_ARRAYLANG['TXT_CONTACT_SETTINGS'],
			'TXT_CONTACT_PROPERTY'						=> $_ARRAYLANG['TXT_CONTACT_PROPERTY'],
			'TXT_CONTACT_VALUE'							=> $_ARRAYLANG['TXT_CONTACT_VALUE'],
			'TXT_CONTACT_SAVE'							=> $_ARRAYLANG['TXT_CONTACT_SAVE'],
			'TXT_CONTACT_FILE_UPLOAD_DEPOSITION_PATH'	=> $_ARRAYLANG['TXT_CONTACT_FILE_UPLOAD_DEPOSITION_PATH']
		));
		
		$this->_objTpl->setVariable('CONTACT_FILE_UPLOAD_DEPOSITION_PATH', $arrSettings['fileUploadDepositionPath']);
	}
	
	function _saveSettings()
	{
		global $objDatabase;
		
		if (isset($_REQUEST['save'])) {
			$fileUploadDepositionPath = isset($_POST['contactFileUploadDepositionPath']) ? contrexx_stripslashes($_POST['contactFileUploadDepositionPath']) : '';
			if (!strpos($fileUploadDepositionPath, '..')) {
				if (!empty($fileUploadDepositionPath)) {
					$objDatabase->Execute("UPDATE ".DBPREFIX."module_contact_settings SET setvalue='".$fileUploadDepositionPath."' WHERE setname='fileUploadDepositionPath'");
				}
			}
			
			$this->initSettings();
		}
	}
	
	function _getContactFormPage()
	{
		switch ($_REQUEST['tpl']) {
		case 'edit':
			$this->_modifyForm();
			break;
			
		case 'copy':
			$this->_modifyForm(true);
			break;
			
		case 'save':
			$this->_saveForm();
			break;
			
		case 'deleteForm':
			$this->_deleteForm();
			break;
			
		case 'deleteEntry':
			$this->_deleteFormEntry();
			break;
			
		case 'code':
			$this->_sourceCode();
			break;
			
		case 'entries':
			$this->_contactFormEntries();
			break;
			
		default:
			$this->_contactForms();
			break;
		}
	}
	
	function _contactFormEntries()
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->loadTemplateFile('module_contact_form_entries.html');
		
		$paging = '';
		$pos = 0;
		$maxFields = 3;
		$formId = isset($_GET['formId']) ? intval($_GET['formId']) : 0;
		
		if ($formId > 0) {
			
			if (isset($_GET['pos'])) {
				$pos = intval($_GET['pos']);
			}
			
			$arrEntries = &$this->getFormEntries($formId, $arrCols, $pos, $paging);
			$arrFormFields = &$this->getFormFields($formId);
			$arrFormFieldNames = &$this->getFormFieldNames($formId);
			
			$this->_objTpl->setGlobalVariable(array(
				'TXT_CONTACT_DELETE_ENTRY'				=> $_ARRAYLANG['TXT_CONTACT_DELETE_ENTRY'],
				'TXT_CONTACT_DETAILS'					=> $_ARRAYLANG['TXT_CONTACT_DETAILS'],
				'CONTACT_FORM_ID'						=> $formId
			));
			
			$this->_objTpl->setVariable(array(
				'TXT_CONTACT_BACK'						=> $_ARRAYLANG['TXT_CONTACT_BACK'],
				'TXT_CONTACT_CONFIRM_DELETE_ENTRY'		=> $_ARRAYLANG['TXT_CONTACT_CONFIRM_DELETE_ENTRY'],
				'TXT_CONTACT_ACTION_IS_IRREVERSIBLE'	=> $_ARRAYLANG['TXT_CONTACT_ACTION_IS_IRREVERSIBLE'],
				'TXT_CONTACT_DATE'						=> $_ARRAYLANG['TXT_CONTACT_DATE'],
				'TXT_CONTACT_FUNCTIONS'					=> $_ARRAYLANG['TXT_CONTACT_FUNCTIONS'],
				'CONTACT_FORM_COL_NUMBER'				=> (count($arrCols) > $maxFields ? $maxFields : count($arrCols)) +2,
				'CONTACT_FORM_ENTRIES_TITLE'			=> str_replace('%NAME%', $this->arrForms[$formId]['name'], $_ARRAYLANG['TXT_CONTACT_ENTRIES_OF_NAME']),
				'CONTACT_FORM_PAGING'					=> $paging
			));
			
			$colNr = 0;
			foreach ($arrCols as $col) {
				if ($colNr == $maxFields) {
					break;
				}
				$this->_objTpl->setVariable('CONTACT_COL_NAME', $col);
				$this->_objTpl->parse('contact_col_names');
				$colNr++;
			}
			
			$rowNr = 0;
			foreach ($arrEntries as $entryId => $arrEntry) {
				$this->_objTpl->setVariable('CONTACT_FORM_ENTRIES_ROW_CLASS', $rowNr % 2 == 0 ? 'row2' : 'row1');
				
				$this->_objTpl->setVariable(array(
					'CONTACT_FORM_DATE'		=> '<a href="index.php?cmd=contact&amp;act=entries&amp;formId='.$formId.'&amp;entryId='.$entryId.'" title="'.$_ARRAYLANG['TXT_CONTACT_DETAILS'].'">'.date(ASCMS_DATE_FORMAT, $arrEntry['time']).'</a>',
					'CONTACT_FORM_ENTRY_ID'	=> $entryId
				));
				
				$this->_objTpl->parse('contact_form_entry_data');
				
				$colNr = 0;
				foreach ($arrCols as $col) {
					if ($colNr == $maxFields) {
						break;
					}
					
					if (isset($arrEntry['data'][$col])) {
						if (isset($arrFormFields[$arrFormFieldNames[$col]]) && $arrFormFields[$arrFormFieldNames[$col]]['type'] == 'file') {
							$value = '<a href="'.ASCMS_PATH_OFFSET.$arrEntry['data'][$col].'" target="_blank" onclick="return confirm(\''.$_ARRAYLANG['TXT_CONTACT_CONFIRM_OPEN_UPLOADED_FILE'].'\')">'.ASCMS_PATH_OFFSET.$arrEntry['data'][$col].'</a>';
						} else {
							$value = $arrEntry['data'][$col];
						}
					} else {
						$value = '&nbsp;';
					}
					if (empty($value)) {
						$value = '&nbsp;';
					}
					
					$this->_objTpl->setVariable('CONTACT_FORM_ENTRIES_CELL_CONTENT', $value);
					$this->_objTpl->parse('contact_form_entry_data');
					
					$colNr++;
				}
				$this->_objTpl->parse('contact_form_entries');
				
				$rowNr++;
			}
		} else {
			$this->_contactForms();
		}
	}
	
	function _contactForms()
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->loadTemplateFile('module_contact_forms_overview.html');
		
		$this->_objTpl->setVariable(array(
			'TXT_CONTACT_CONFIRM_DELETE_FORM'	=> $_ARRAYLANG['TXT_CONTACT_CONFIRM_DELETE_FORM'],
			'TXT_CONTACT_FORM_ENTRIES_WILL_BE_DELETED'	=> $_ARRAYLANG['TXT_CONTACT_FORM_ENTRIES_WILL_BE_DELETED'],
			'TXT_CONTACT_ACTION_IS_IRREVERSIBLE'		=> $_ARRAYLANG['TXT_CONTACT_ACTION_IS_IRREVERSIBLE'],
			'TXT_CONTACT_LATEST_ENTRY'					=> $_ARRAYLANG['TXT_CONTACT_LATEST_ENTRY'],
			'TXT_CONTACT_NUMBER_OF_ENTRIES'				=> $_ARRAYLANG['TXT_CONTACT_NUMBER_OF_ENTRIES'],
			'TXT_CONTACT_CONTACT_FORMS'					=> $_ARRAYLANG['TXT_CONTACT_CONTACT_FORMS'],
			'TXT_CONTACT_ID'							=> $_ARRAYLANG['TXT_CONTACT_ID'],
			'TXT_CONTACT_NAME'							=> $_ARRAYLANG['TXT_CONTACT_NAME'],
			'TXT_CONTACT_FUNCTIONS'						=> $_ARRAYLANG['TXT_CONTACT_FUNCTIONS'],
			'TXT_CONTACT_ADD_NEW_CONTACT_FORM'			=> $_ARRAYLANG['TXT_CONTACT_ADD_NEW_CONTACT_FORM']
		));
		
		$this->_objTpl->setGlobalVariable(array(
			'TXT_CONTACT_SHOW_ENTRIES'					=> $_ARRAYLANG['TXT_CONTACT_SHOW_ENTRIES'],
			'TXT_CONTACT_MODIFY'						=> $_ARRAYLANG['TXT_CONTACT_MODIFY'],
			'TXT_CONTACT_DELETE'						=> $_ARRAYLANG['TXT_CONTACT_DELETE'],
			'TXT_CONTACT_SHOW_SOURCECODE'				=> $_ARRAYLANG['TXT_CONTACT_SHOW_SOURCECODE'],
			'TXT_CONTACT_USE_AS_TEMPLATE'				=> $_ARRAYLANG['TXT_CONTACT_USE_AS_TEMPLATE']
		));
		
		$rowNr = 0;
		if (is_array($this->arrForms)) {
			foreach ($this->arrForms as $formId => $arrForm) {
				$this->_objTpl->setVariable(array(
					'CONTACT_FORM_ROW_CLASS'			=> $rowNr % 2 == 1 ? 'row1' : 'row2',
					'CONTACT_FORM_ID'					=> $formId,
					'CONTACT_FORM_NAME'					=> $arrForm['name'],
					'CONTACT_FORM_LAST_ENTRY'			=> $arrForm['last'] ? date(ASCMS_DATE_FORMAT, $arrForm['last']) : '&nbsp;',
					'CONTACT_FORM_NUMBER_OF_ENTRIES'	=> $arrForm['number']
				));
				$this->_objTpl->parse('contact_contact_forms');
				
				$rowNr++;
			}
		}
	}
	
	function _modifyForm($copy = false)
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->loadTemplateFile('module_contact_form_modify.html');
		
		$this->_objTpl->setVariable(array(
			'TXT_CONTACT_NAME'								=> $_ARRAYLANG['TXT_CONTACT_NAME'],
			'TXT_CONTACT_RECEIVER_ADDRESSES'				=> $_ARRAYLANG['TXT_CONTACT_RECEIVER_ADDRESSES'],
			'TXT_CONTACT_ADD_OTHER_FIELD'					=> $_ARRAYLANG['TXT_CONTACT_ADD_OTHER_FIELD'],
			'TXT_CONTACT_SAVE'								=> $_ARRAYLANG['TXT_CONTACT_SAVE'],
			'TXT_CONTACT_SEPARATE_MULTIPLE_VALUES_BY_COMMA'	=> $_ARRAYLANG['TXT_CONTACT_SEPARATE_MULTIPLE_VALUES_BY_COMMA']
		));
		
		$this->_objTpl->setGlobalVariable(array(
			'TXT_CONTACT_FORM_FIELDS'						=> $_ARRAYLANG['TXT_CONTACT_FORM_FIELDS'],
			'TXT_CONTACT_DELETE'							=> $_ARRAYLANG['TXT_CONTACT_DELETE'],
			'TXT_CONTACT_MOVE_UP'							=> $_ARRAYLANG['TXT_CONTACT_MOVE_UP'],
			'TXT_CONTACT_MOVE_DOWN'							=> $_ARRAYLANG['TXT_CONTACT_MOVE_DOWN']
		));
		
		$formId = isset($_REQUEST['formId']) ? intval($_REQUEST['formId']) : 0;
		$lastFieldId = 0;
		
		if (isset($_POST['saveForm'])) {
			$arrFields = $this->_getFormFieldsFromPost($null);
			$formName = isset($_POST['contactFormName']) ? contrexx_stripslashes($_POST['contactFormName']) : '';
			$formEmails = isset($_POST['contactFormEmail']) ? contrexx_stripslashes($_POST['contactFormEmail']) : '';
		} elseif (isset($this->arrForms[$formId])) {
			$arrFields = &$this->getFormFields($formId);
			$formName = $this->arrForms[$formId]['name'];
			$formEmails = $this->arrForms[$formId]['emails'];
		} else {
			$formName = '';
			$formEmails = '';
		}
		
		if ($copy) {
			$formId = 0;
		}
		
		if (is_array($arrFields)) {
			foreach ($arrFields as $fieldId => $arrField) {
				$this->_objTpl->setVariable(array(
					'CONTACT_FORM_FIELD_NAME'				=> $arrField['name'],
					'CONTACT_FORM_FIELD_ID'					=> $fieldId,
					'CONTACT_FORM_FIELD_TYPE_MENU'			=> $this->_getFormFieldTypesMenu('contactFormFieldType['.$fieldId.']', $arrField['type'], 'id="contactFormFieldType_'.$fieldId.'" onchange="setFormFieldAttributeBox(this.getAttribute(\'id\'), this.value)"'),
					'CONTACT_FORM_FIELD_ATTRIBUTES'			=> $this->_getFormFieldAttribute($fieldId, $arrField['type'], $arrField['attributes'])
				));
				$this->_objTpl->parse('contact_form_field_list');
				
				$lastFieldId = $fieldId > $lastFieldId ? $fieldId : $lastFieldId;
			}
		}
		
		if (isset($this->arrForms[$formId])) {
			$actionTitle = $_ARRAYLANG['TXT_CONTACT_MODIFY_CONTACT_FORM'];
		} else {
			$actionTitle = $_ARRAYLANG['TXT_CONTACT_ADD_NEW_CONTACT_FORM'];
		}
		
		$this->_objTpl->setVariable(array(
			'CONTACT_FORM_NAME'								=> $formName,
			'CONTACT_FORM_EMAIL'							=> $formEmails,
			'CONTACT_FORM_FIELD_NEXT_ID'					=> $lastFieldId+1,
			'CONTACT_FORM_FIELD_NEXT_TEXT_TPL'				=> $this->_getFormFieldAttribute($lastFieldId+1, 'text', ''),
			'CONTACT_ACTION_TITLE'							=> $actionTitle,
			'CONTACT_FORM_ID'								=> $formId,
			'CONTACT_FORM_FIELD_TYPE_MENU_TPL'				=> $this->_getFormFieldTypesMenu('contactFormFieldType['.($lastFieldId+1).']', key($this->_arrFormFieldTypes), 'id="contactFormFieldType_'.($lastFieldId+1).'" onchange="setFormFieldAttributeBox(this.getAttribute(\'id\'), this.value)"'),
			'CONTACT_FORM_FIELD_TEXT_TPL'					=> $this->_getFormFieldAttribute(0, 'text', ''),
			'CONTACT_FORM_FIELD_CHECKBOX_TPL'				=> $this->_getFormFieldAttribute(0, 'checkbox', 0),
			'CONTACT_FORM_FIELD_CHECKBOX_GROUP_TPL'			=> $this->_getFormFieldAttribute(0, 'checkboxGroup', ''),
			'CONTACT_FORM_FIELD_HIDDEN_TPL'					=> $this->_getFormFieldAttribute(0, 'hidden', ''),
			'CONTACT_FORM_FIELD_RADIO_TPL'					=> $this->_getFormFieldAttribute(0, 'radio', ''),
			'CONTACT_FORM_FIELD_SELECT_TPL'					=> $this->_getFormFieldAttribute(0, 'select', '')
		));
	}
	
	function _getFormFieldAttribute($id, $type, $attr)
	{
		global $_ARRAYLANG;
		
		switch ($type) {
		case 'text':
			return $_ARRAYLANG['TXT_CONTACT_DEFAULT_VALUE'].": <input type=\"text\" name=\"contactFormFieldAttribute[".$id."]\" value=\"".$attr."\" />\n";
			break;
			
		case 'checkbox':
			return "<select name=\"contactFormFieldAttribute[".$id."]\">\n
						<option value=\"0\"".($attr == 0 ? ' selected="selected"' : '').">".$_ARRAYLANG['TXT_CONTACT_NOT_SELECTED']."</option>\n
						<option value=\"1\"".($attr == 1 ? ' selected="selected"' : '').">".$_ARRAYLANG['TXT_CONTACT_SELECTED']."</option>\n
					</select>";
			break;
			
		case 'checkboxGroup':
			return $_ARRAYLANG['TXT_CONTACT_OPTIONS'].": <input type=\"text\" name=\"contactFormFieldAttribute[".$id."]\" value=\"".$attr."\" /> *\n";
			break;
		
		case 'hidden':
			return $_ARRAYLANG['TXT_CONTACT_VALUE'].": <input type=\"text\" name=\"contactFormFieldAttribute[".$id."]\" value=\"".$attr."\" />\n";
			break;
		
		case 'select':
		case 'radio':
			return $_ARRAYLANG['TXT_CONTACT_VALUES'].": <input type=\"text\" name=\"contactFormFieldAttribute[".$id."]\" value=\"".$attr."\" /> *\n";
			break;
			
		default:
			return '';
			break;
		}
	}
	
	function _saveForm()
	{
		global $_ARRAYLANG;
		
		if (isset($_POST['saveForm'])) {
			$formId = isset($_REQUEST['formId']) ? intval($_REQUEST['formId']) : 0;
			$formName = isset($_POST['contactFormName']) ? contrexx_stripslashes($_POST['contactFormName']) : '';
			if (!empty($formName)) {
				if ($this->isUniqueFormName($formName, $formId)) {
					$arrFields = $this->_getFormFieldsFromPost($uniqueFieldNames);
					if ($uniqueFieldNames) {
						$formEmailsTmp = isset($_POST['contactFormEmail']) ? explode(',', contrexx_stripslashes($_POST['contactFormEmail'])) : '';
						
						if (is_array($formEmailsTmp)) {
							$formEmails = array();
							foreach ($formEmailsTmp as $email) {
								$email = trim(contrexx_strip_tags($email));
								if (!empty($email)) {
									array_push($formEmails, $email);
								}
							}
							$formEmails = implode(',', $formEmails);
						} else {
							$formEmails = '';
						}
						
						if ($formId > 0) {
							$this->updateForm($formId, $formName, $formEmails, $arrFields);
						} else {
							$this->addForm($formName, $formEmails, $arrFields);
						}
						$this->_statusMessage .= $_ARRAYLANG['TXT_CONTACT_FORM_SUCCESSFULLY_SAVED'];
						$this->_contactForms();
					} else {
						$this->_statusMessage .= $_ARRAYLANG['TXT_CONTACT_FORM_FIELD_UNIQUE_MSG'];
						$this->_modifyForm();
					}
				} else {
					$this->_statusMessage .= $_ARRAYLANG['TXT_CONTACT_FORM_NAME_IS_NOT_UNIQUE_MSG'];
					$this->_modifyForm();
				}
			} else {
				$this->_statusMessage .= $_ARRAYLANG['TXT_CONTACT_FORM_NAME_REQUIRED_MSG'];
				$this->_modifyForm();
			}
		} else {
			$this->_modifyForm();
		}
	}
	
	function _deleteFormEntry()
	{
		if (isset($_GET['entryId'])) {
			$entryId = intval($_GET['entryId']);
			$this->deleteFormEntry($entryId);
		}
		$this->_contactFormEntries();
	}
	
	function _deleteForm()
	{
		if (isset($_GET['formId'])) {
			$formId = intval($_GET['formId']);
		
			if ($formId > 0) {
				$this->deleteForm($formId);
			}
		}
		$this->_contactForms();
	}
	
	function _getFormFieldsFromPost(&$uniqueFieldNames)
	{
		$uniqueFieldNames = true;
		$arrFields = array();
		$arrFieldNames = array();
		$orderId = 0;
		
		if (isset($_POST['contactFormFieldName']) && is_array($_POST['contactFormFieldName'])) {
			foreach ($_POST['contactFormFieldName'] as $id => $fieldName) {
				$type = isset($_POST['contactFormFieldType'][$id]) && array_key_exists(contrexx_stripslashes($_POST['contactFormFieldType'][$id]), $this->_arrFormFieldTypes) ? contrexx_stripslashes($_POST['contactFormFieldType'][$id]) : key($this->_arrFormFieldTypes);
				$attributes = isset($_POST['contactFormFieldAttribute'][$id]) && !empty($_POST['contactFormFieldAttribute'][$id]) ? ($type == 'text' || $type == 'file' || $type == 'textarea' || $type == 'hidden' || $type == 'radio' || $type == 'checkboxGroup' || $type == 'password' || $type == 'select' ? contrexx_stripslashes($_POST['contactFormFieldAttribute'][$id]) : intval($_POST['contactFormFieldAttribute'][$id])) : '';
				
				if (!in_array(contrexx_strip_tags($fieldName), $arrFieldNames)) {
					array_push($arrFieldNames, contrexx_strip_tags($fieldName));
				} else {
					$uniqueFieldNames = false;
				}
				$arrFields[intval($id)] = array(
					'name'			=> contrexx_strip_tags($fieldName),
					'type'			=> $type,
					'attributes'	=> $attributes,
					'order_id'		=> $orderId
				);
				
				$orderId++;
			}
		}
		return $arrFields;
	}
	
	function _getFormFieldTypesMenu($name, $selectedType, $attrs = '')
	{
		
		$menu = "<select name=\"".$name."\" ".$attrs.">\n";
		
		foreach ($this->_arrFormFieldTypes as $type => $desc) {
			$menu .= "<option value=\"".$type."\"".($selectedType == $type ? 'selected="selected"' : '').">".$desc."</option>\n";
		}
		
		$menu .= "</select>\n";
		return  $menu;
	}
	
	function _sourceCode()
	{
		global $_ARRAYLANG;
		
		$formId = isset($_REQUEST['formId']) ? intval($_REQUEST['formId']) : 0;
		
		if ($formId > 0 && isset($this->arrForms[$formId])) {
			$this->_objTpl->loadTemplateFile('module_contact_form_code.html');
			
			$this->_objTpl->setVariable(array(
				'TXT_CONTACT_SOURCECODE'			=> $_ARRAYLANG['TXT_CONTACT_SOURCECODE'],
				'TXT_CONTACT_PREVIEW'				=> $_ARRAYLANG['TXT_CONTACT_PREVIEW'],
				'TXT_CONTACT_COPY_SOURCECODE_MSG'	=> $_ARRAYLANG['TXT_CONTACT_COPY_SOURCECODE_MSG'],
				'TXT_CONTACT_SELECT_ALL'			=> $_ARRAYLANG['TXT_CONTACT_SELECT_ALL'],
				'TXT_CONTACT_BACK'					=> $_ARRAYLANG['TXT_CONTACT_BACK']
			));
			
			$this->_objTpl->setVariable(array(
				'CONTACT_SOURCECODE_OF'				=> str_replace('%NAME%', $this->arrForms[$formId]['name'], $_ARRAYLANG['TXT_CONTACT_SOURCECODE_OF_NAME']),
				'CONTACT_PREVIEW_OF'				=> str_replace('%NAME%', $this->arrForms[$formId]['name'], $_ARRAYLANG['TXT_CONTACT_PREVIEW_OF_NAME']),
				'CONTACT_FORM_SOURCECODE'			=> htmlentities($this->_getSourceCode($formId)),
				'CONTACT_FORM_PREVIEW'				=> $this->_getSourceCode($formId, true)
			));
		} else {
			$this->_contactForms();
		}
	}
	
	function _getSourceCode($id, $preview = false)
	{
		global $_ARRAYLANG;
		
		$sourcecode = "<form action=\"".($preview ? '../' : '')."index.php?section=contact&amp;id=".$id."&amp;cmd=thanks\" method=\"post\" enctype=\"multipart/form-data\">\n";
		$sourcecode .= "<table border=\"0\">\n";
		
		$arrFields = $this->getFormFields($id);
		
		foreach ($arrFields as $fieldId => $arrField) {
			$sourcecode .= "<tr>\n";
			$sourcecode .= "<td style=\"width:100px;\">".($arrField['type'] != 'hidden' ? $arrField['name'] : '&nbsp;')."</td>\n";
			$sourcecode .= "<td>";
			
			switch ($arrField['type']) {
				case 'text':
					$sourcecode .= "<input style=\"width:300px;\" type=\"text\" name=\"contactFormField_".$fieldId."\" value=\"".$arrField['attributes']."\" />\n";
					break;
					
				case 'checkbox':
					$sourcecode .= "<input type=\"checkbox\" name=\"contactFormField_".$fieldId."\" value=\"1\"".($arrField['attributes'] == '1' ? ' checked="checked"' : '')." />\n";
					break;
					
				case 'checkboxGroup':
					$options = explode(',', $arrField['attributes']);
					$nr = 0;
					foreach ($options as $option) {
						$sourcecode .= "<input type=\"checkbox\" name=\"contactFormField_".$fieldId."[]\" id=\"contactFormField_".$nr."_".$fieldId."\" value=\"".$option."\" /><label for=\"contactFormField_".$nr."_".$fieldId."\">".$option."</label>\n";
						$nr++;
					}
					break;
					
				case 'file':
					$sourcecode .= "<input style=\"width:300px;\" type=\"file\" name=\"contactFormField_".$fieldId."\" />\n";
					break;
					
				case 'hidden':
					$sourcecode .= "<input type=\"hidden\" name=\"contactFormField_".$fieldId."\" value=\"".$arrField['attributes']."\" />\n";
					break;
					
				case 'password':
					$sourcecode .= "<input style=\"width:300px;\" type=\"password\" name=\"contactFormField_".$fieldId."\" value=\"\" />\n";
					break;
					
				case 'radio':
					$options = explode(',', $arrField['attributes']);
					$nr = 0;
					foreach ($options as $option) {
						$sourcecode .= "<input type=\"radio\" name=\"contactFormField_".$fieldId."\" id=\"contactFormField_".$nr."_".$fieldId."\" value=\"".$option."\" /><label for=\"contactFormField_".$nr."_".$fieldId."\">".$option."</label>\n";
						$nr++;
					}
					break;
					
				case 'select':
					$options = explode(',', $arrField['attributes']);
					$nr = 0;
					$sourcecode .= "<select style=\"width:300px;\" name=\"contactFormField_".$fieldId."\">\n";
					foreach ($options as $option) {
						$sourcecode .= "<option>".$option."</option>\n";
					}
					$sourcecode .= "</select>\n";
					break;
					
				case 'textarea':
					$sourcecode .= "<textarea style=\"width:300px; height:100px;\" name=\"contactFormField_".$fieldId."\"></textarea>\n";
					break;
			}
			
			$sourcecode .= "</td>\n";
			$sourcecode .= "</tr>\n";
		}
		$sourcecode .= "<tr>\n";
		$sourcecode .= "<td>&nbsp;</td>\n";
		$sourcecode .= "<td>\n";
		$sourcecode .= "<input type=\"reset\" value=\"".$_ARRAYLANG['TXT_CONTACT_DELETE']."\" /> <input type=\"submit\" value=\"".$_ARRAYLANG['TXT_CONTACT_SUBMIT']."\" />\n";
		$sourcecode .= "</td>\n";
		$sourcecode .= "</tr>\n";
		$sourcecode .= "</table>\n";
		
		$sourcecode .= "</form>";
		
		return $sourcecode;
	}
	
	function _getEntryDetails($arrEntry, $formId)
	{
		global $_ARRAYLANG;
		
		$arrFormFields = $this->getFormFields($formId);
		$rowNr = 0;
		
		$sourcecode .= "<table border=\"0\" class=\"adminlist\" cellpadding=\"3\" cellspacing=\"0\" width=\"100%\">\n";
		foreach ($arrFormFields as $arrField) {
			$sourcecode .= "<tr class=".($rowNr % 2 == 0 ? 'row1' : 'row2').">\n";
			$sourcecode .= "<td width=\"15%\">".$arrField['name'].($arrField['type'] == 'hidden' ? ' (hidden)' : '')."</td>\n";
			$sourcecode .= "<td width=\"85%\">";
			
			switch ($arrField['type']) {
				case 'checkbox':
					$sourcecode .= isset($arrEntry['data'][$arrField['name']]) && $arrEntry['data'][$arrField['name']] ? ' '.$_ARRAYLANG['TXT_CONTACT_YES'] : ' '.$_ARRAYLANG['TXT_CONTACT_NO'];
					break;
					
				case 'file':
					$sourcecode .= isset($arrEntry['data'][$arrField['name']]) ? '<a href="'.ASCMS_PATH_OFFSET.$arrEntry['data'][$arrField['name']].'" target="_blank" onclick="return confirm(\''.$_ARRAYLANG['TXT_CONTACT_CONFIRM_OPEN_UPLOADED_FILE'].'\')">'.ASCMS_PATH_OFFSET.$arrEntry['data'][$arrField['name']].'</a>' : '&nbsp;';
					break;
					
				case 'text':
				case 'checkboxGroup':
				case 'hidden':
				case 'password':
				case 'radio':
				case 'select':
				case 'textarea':
					$sourcecode .= isset($arrEntry['data'][$arrField['name']]) ? $arrEntry['data'][$arrField['name']] : '&nbsp;';
					break;
			}
			
			$sourcecode .= "</td>\n";
			$sourcecode .= "</tr>\n";
			
			$rowNr++;
		}
		$sourcecode .= "</table>\n";
		
		return $sourcecode;
	}
}
?>
