<?php
/**
* Modul Calendar
*
* LibClass to manage cms calendar
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>   
* @module Calendar
* @modulegroup   modules
* @access public
* @version 1.0.0  
**/

require_once dirname(__FILE__) . "/lib/activecalendar/activecalendar.php";

class calendarLibrary
{
    var $_objTpl;
    var $statusMessage;
    var $calDay;
    var $calMonth;
    var $calYear;
    var $calDate;
    var $calDate2;
    var $calDate3;
    var $calendarDay;
    
	var $calStartYear;
	var $calEndYear;
	var $paging;
	
	var $calendarMonth;
	
	var $url;
	var $monthnavur=null;
	
	var $showOnlyActive = true;
	
	
	/**
	 * PHP 5 Constructor
	 */
	function __construct($url)
	{
		$this->calendarLibrary($url);	
	}
	
	
	/**
	 * Constructor for php 4
	 */
	function calendarLibrary($url)
	{
	    global $_CONFIG;
	    
	   	$this->calStartYear = 2004;
	    $this->calEndYear   = 2037;
	    $this->paging       = intval($_CONFIG['corePagingLimit']);
	    
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/calendar/template');
        $this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
	    
		$this->url = $url;
	}
    
	
	
	// write month names
	function monthName($month)
	{	
	    global $_ARRAYLANG;
	    
		$months = explode(',', $_ARRAYLANG['TXT_MONTH_ARRAY']);
		$name = $months[$month - 1];
		return $name;	
	}
	
	// get day note
	function getDayNote($id, $showboxes=true)
	{
	    global $objDatabase, $_ARRAYLANG, $_LANGID;
				
		$query = "SELECT id,
		                   catid,
		                   startdate, 
		                   enddate, 
		                   priority, 
		                   name, 
		                   comment, 
		                   place,
		                   info
		              FROM ".DBPREFIX."module_calendar
		             WHERE id = '".intval($id)."'";
		
		$objResult = $objDatabase->Execute($query);
		
		$title		= date(ASCMS_DATE_SHORT_FORMAT, $objResult->fields['startdate']);
		$start		= date(ASCMS_DATE_FORMAT, $objResult->fields['startdate']);
		$end		= date(ASCMS_DATE_FORMAT, $objResult->fields['enddate']);
		$comment   	= stripslashes($objResult->fields['comment']);
		
		if ($showboxes) {
			$boxes = $this->getBoxes(3, date("Y", $objResult->fields['startdate']),
				date("m", $objResult->fields['startdate']),
				date("d", $objResult->fields['startdate']));
		}
	
		$this->_objTpl->setVariable("CALENDAR", $boxes);
	
		if( $objResult->fields['priority'] == 1){
			$priority_gif = 'priority2h';
		}
		elseif ($objResult->fields['priority'] == 2) {
			$priority_gif = 'priorityh';
		}
		elseif ($objResult->fields['priority'] == 3) {
			$priority_gif = 'priorityno';
		}
		elseif ($objResult->fields['priority'] == 4) {
			$priority_gif = 'priorityl';
		}
		elseif ($objResult->fields['priority'] == 5) {
			$priority_gif = 'priority2l';
		}
		
		$query = "SELECT name
		               FROM ".DBPREFIX."module_calendar_categories
		              WHERE id = '".$objResult->fields['catid']."'";
		$objResult2 = $objDatabase->SelectLimit($query);
	    
	    // parse to template
		$this->_objTpl->setVariable(array(
		    'TXT_CALENDAR_CAT'          => $_ARRAYLANG['TXT_CALENDAR_CAT'],
			'TXT_CALENDAR_DATE'		    => $_ARRAYLANG['TXT_CALENDAR_DATE'],
			'TXT_CALENDAR_NAME'		    => $_ARRAYLANG['TXT_CALENDAR_NAME'],
			'TXT_CALENDAR_PLACE'	    => $_ARRAYLANG['TXT_CALENDAR_PLACE'],
			'TXT_CALENDAR_PRIORITY'	    => $_ARRAYLANG['TXT_CALENDAR_PRIORITY'],
			'TXT_CALENDAR_START'	    => $_ARRAYLANG['TXT_CALENDAR_START'],
			'TXT_CALENDAR_END'		    => $_ARRAYLANG['TXT_CALENDAR_END'],
			'TXT_CALENDAR_COMMENT'	    => $_ARRAYLANG['TXT_CALENDAR_COMMENT'],
			'TXT_CALENDAR_BACK'         => $_ARRAYLANG['TXT_CALENDAR_BACK'],
			'CALENDAR_TITLE'		    => $title,
			'CALENDAR_NAME'			    => htmlentities($objResult->fields['name']),
			'CALENDAR_PLACE'		    => htmlentities($objResult->fields['place']),
			'CALENDAR_PRIORITY_GIF'     => $priority_gif,
			'CALENDAR_PRIORITY'		    => $objResult->fields['priority'],
			'CALENDAR_START'		    => $start,
			'CALENDAR_END'			    => $end,
			'CALENDAR_COMMENT'		    => $comment,
			'CALENDAR_ID'			    => $id,
			'CALENDAR_CAT'              => stripslashes($objResult2->fields['name'])
		));
		
		if (!empty($objResult->fields['info'])) {
			$info = $info_href = $objResult->fields['info'];
			if (strlen($info) > 50) {
				$info = substr($info, 0, 47);
				$info .= "...";
			}
			$this->_objTpl->setVariable(array(
				'TXT_CALENDAR_INFO'         => $_ARRAYLANG['TXT_CALENDAR_INFO'],
				'CALENDAR_INFO'             => $info,
				'CALENDAR_INFO_HREF'        => $info_href
			));
			
		} else {
			$this->_objTpl->hideBlock("infolink");
		}
	}
  
  /**
   *  function dateNumber
   *
   *  convert date-number from one-digit to two-digit
   */
  
  function dateNumber($number)
  {
      $number = intval($number);
      if(strlen($number)==1)
      {
          $number = '0'.$number;
      }
      return $number;
  }//end function	
	
  
	/**
	 * Get Boxes
	 *
	 * Returns 3 calendar Boxes
	 */
	function getBoxes($howmany, $year, $month=0, $day=0, $catid=NULL)
	{
		global $objDatabase, $_ARRAYLANG;
		
		$url = htmlentities($this->url);
		
		if (empty($catid)) {
			if (empty($_GET['catid'])) {
				$catid = 0;
			} else {
				$catid = $_GET['catid'];
			}
		}
		
		$url.="&amp;catid=$catid";
		
		$month = intval($month);
		$year = intval($year);
		$day = intval($day);
		$firstblock = true;
		
		$monthnames = explode(",", $_ARRAYLANG['TXT_MONTH_ARRAY']);
		
		for ($i=0; $i<$howmany; $i++) {
		
			$cal = new activeCalendar($year, $month, $day);
			$cal->setMonthNames($monthnames);
			if ($firstblock) {
				$cal->enableMonthNav($url);
			} else {
				// This is necessary for the modification of the linkname
				// The modification makes a link on the monthname
				$cal->urlNav=$url;	
			}
			
			// for seperate variable for the month links
			if (!empty($this->monthnavurl)) {
				$cal->urlMonthNav = htmlentities($this->monthnavurl);
			}
			
			// get events
			if (empty($catid)) {
				$query = "SELECT * FROM ".DBPREFIX."module_calendar";
			} else {
				$query = "SELECT * FROM ".DBPREFIX."module_calendar
						  WHERE catid=$catid";				  
			}
			$objResult = $objDatabase->Execute($query);
					
			while (!$objResult->EOF) {
				if (($objResult->fields['active'] == 1 && $this->showOnlyActive) || !$this->showOnlyActive) {
					$startdate = $objResult->fields['startdate'];
					$enddate = $objResult->fields['enddate'];
					
					$eventYear 	= date("Y", $startdate);
					$eventMonth = date("m", $startdate);
					$eventDay	= date("d", $startdate);
					
					$eventEndDay = date("d", $enddate);
					$eventEndMonth = date("m", $enddate);
					
					// do only something when the event is in the current month
					if ($eventMonth == $month || $eventEndMonth == $month) {
						// if the event is longer than one day but every day is in the same month
						if ($eventEndDay > $eventDay && $eventMonth == $eventEndMonth) {
							$curday = $eventDay;
							while ($curday <= $eventEndDay) {
								$eventurl = $url."&amp;yearID=$eventYear&amp;monthID=$eventMonth&amp;dayID=$curday";
								$cal->setEvent("$eventYear", "$eventMonth", "$curday", false, $eventurl);
	
								$curday++;
							}
						} elseif ($eventEndMonth > $eventMonth) {
							if ($eventMonth == $month) {
								// Show the part of the event in the starting month
								$curday = $eventDay;
								while ($curday <= 31) {
									$eventurl = $url."&amp;yearID=$eventYear&amp;monthID=$eventMonth&amp;dayID=$curday";
									$cal->setEvent("$eventYear", "$eventMonth", "$curday", false, $eventurl);
	
									$curday++;
								}
							} elseif ($eventEndMonth == $month) {
								// show the part of the event in the ending month
								$curday = $eventEndDay;
								while ($curday > 0) {
									$eventurl = $url."&amp;yearID=$eventYear&amp;monthID=$eventMonth&amp;dayID=$curday";
									$cal->setEvent("$eventYear", "$eventEndMonth", "$curday", false, $eventurl);
	
									$curday--;
								}
							}
						} else {	
							$eventurl = $url."&amp;yearID=$eventYear&amp;monthID=$eventMonth&amp;dayID=$eventDay";
							$cal->setEvent("$eventYear", "$eventMonth", "$eventDay", false, $eventurl);	
						}
					}
				}
				$objResult->MoveNext();
			}
			$retval .= $cal->showMonth();
			
			if ($month == 12) {
				$year++;
				$month = 1;
			} else {
				$month++;
			}
			$day = 0;
			
			$firstblock = false;
		}
		
		return $retval;
	}
		
	
	/**
	 * Category List
	 *
	 * Returns multiple <option> tags for the
	 * list of categories
	 */
	function category_list($selected_var, $name="categories") {
		global $objDatabase, $_ARRAYLANG;
		
		$calendar_categories = "<form action=\"#\" id=\"selectcat\">
			<select name=\"$name\" onchange=\"changecat()\">
				<option value=\"0\">".$_ARRAYLANG['TXT_CALENDAR_ALL_CAT']."</option>";
		
		// makes the category list
    	$query = "SELECT id,name,lang FROM ".DBPREFIX."module_calendar_categories ORDER BY pos";
		$objResult = $objDatabase->Execute($query);
		
		while (!$objResult->EOF) {
			if ($objResult->fields['id'] == $selected_var) {
				$selected = " selected=\"selected\"";
			} else {
				$selected = "";
			}				
			
			$calendar_categories .= "<option value=\"".$objResult->fields['id']."\"$selected>".$objResult->fields['name']."</option>";
			$objResult->MoveNext();
		}	
		
		$calendar_categories .= "
				</select>
			</form>";
	
		return $calendar_categories;
	}
}
?>
